/*
 * Copyright (C) 1994, Silicon Graphics, Inc.
 * All Rights Reserved.
 *
 * This is UNPUBLISHED PROPRIETARY SOURCE CODE of Silicon Graphics, Inc.;
 * the contents of this file may not be disclosed to third parties, copied or
 * duplicated in any form, in whole or in part, without the prior written
 * permission of Silicon Graphics, Inc.
 *
 * RESTRICTED RIGHTS LEGEND:
 * Use, duplication or disclosure by the Government is subject to restrictions
 * as set forth in subdivision (c)(1)(ii) of the Rights in Technical Data
 * and Computer Software clause at DFARS 252.227-7013, and/or in similar or
 * successor clauses in the FAR, DOD or NASA FAR Supplement. Unpublished -
 * rights reserved under the Copyright Laws of the United States.
 */
/*
|   Description:
|      A component class that creates a gizmo for editing textures of a noodle.
|
|   Author(s)          : Paul Isaacs
|
*/


#ifndef _NOODLE_TEXTURE_GIZMO_
#define _NOODLE_TEXTURE_GIZMO_

#include <Xm/Xm.h>
#include <Inventor/Xt/SoXtComponent.h>

extern class GeneralizedCylinder;
extern class NoodleSlider;

class NoodleTextureGizmo : public SoXtComponent {
  public:
    NoodleTextureGizmo( 
	Widget parent = NULL,
	const char *name = NULL, 
	SbBool buildInsideParent = TRUE);
    ~NoodleTextureGizmo();

     void setNoodle( GeneralizedCylinder *newNoodle );

  // internal:
      Widget buildWidget( Widget parent );

  private:
      Widget         _rowCol;
      Widget         textureToggle;
      NoodleSlider  *xRepeatSlider;
      NoodleSlider  *yRepeatSlider;
      NoodleSlider  *xTranslSlider;
      NoodleSlider  *yTranslSlider;
      NoodleSlider  *texRotationSlider;

      GeneralizedCylinder *myNoodle;

      static void textureToggleCallback( Widget, XtPointer, XtPointer);
      static void xTranslCallback( void *, void *);
      static void yTranslCallback( void *, void *);
      static void xRepeatCallback( void *, void *);
      static void yRepeatCallback( void *, void *);
      static void texRotationCallback( void *, void *);
};

#endif /* _NOODLE_TEXTURE_GIZMO_ */
